// 20palmake.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

#include <cstring>
#include <cstdlib>
#include <time.h>

//http://www.shikadi.net/moddingwiki/PCX_Format


struct headPcx
{
	char sig;  //0x0A
	char ver; //2 pal
	char enc;  // 1 RLE
	char numbit; // bits per pixel
	short xmin;
	short ymin;
	short xmax;
	short ymax;

	short horiz;
	short vert;

	char pal[48];
	char reserved;
	char numPlane;
	short bitPerLine;
	short palType;
	char filling[58];
};//classend

struct pColor
{
	unsigned char r,g,b;
};//pcolor


void genPal(pColor pal[256])
{

	int i;
	for (i = 0; i < 11; i++)
	{
		pal[i].r = 0;
		pal[i].g = 0;
		pal[i].b = 0;	
	}//nexti

	for (i = 245; i < 256; i++)
	{
		pal[i].r = 0;
		pal[i].g = 0;
		pal[i].b = 0;	
	}//nexti

	pColor ref;

	int k;

	srand ( time(NULL) );

	//234
	for (i = 11; i < 245; i += 6)
	{
		ref.r = rand() % 256 + 48;
		ref.g = rand() % 256 + 48;
		ref.b = rand() % 256 + 48;

		for (k = 0; k < 6; k++)
		{
			pal[i+k] = ref;
			ref.r = (unsigned char) (((float) ref.r) * 0.78f);
			ref.g = (unsigned char) (((float) ref.g) * 0.78f);
			ref.b = (unsigned char) (((float) ref.b) * 0.78f);
		
		}//nextk

	}//nexti

	//gray colors 
	for (i = 0; i <12; i++)
	{
		pal[i+11].r = (256-i) * 21;
		pal[i+11].g = (256-i) * 21;
		pal[i+11].b = (256-i) * 21;

	}//nexti


}//genpal


void checkKnp()
{
	FILE * f;
	f = fopen("KNP256.PCX","rb");

	headPcx head;

	fread(&head, 128, 1, f);

	fclose(f);

}//file

void savePcx()
{
	headPcx head;

	memset(&head,0,sizeof(headPcx ) ); 

	head.sig = 0x0A;
	head.ver = 5; //2;
	head.enc = 1;
	head.numbit = 8;
	head.horiz = 640; // 72;
	head.vert = 480; //72;
	head.numPlane = 1;

//	It is interesting to note that "Xmax - Xmin + 1" represents the width of the image and that "Ymax - Ymin + 1" represents the height of the same.
	head.xmax = 16-1;
	head.ymax = 16-1;
	head.bitPerLine = head.xmax + 1;
	head.palType = 0; // 1; //color

	int i;
	char data[16*16*2];
	pColor pal[256];

	int k;

	for (i = 0; i < 256; i++)
	{
		k = i* 2;
		data[k] = 0;
		data[k+1] = i;

		//todo -- make colors randomized
		pal[i].r = i;
		pal[i].g = i;
		pal[i].b = i;
	}//nexti


	genPal(pal);



	FILE * f = 0;
	 f = fopen ( "pal256.pcx" , "wb" );

	 fwrite(&head, sizeof(headPcx),1, f);
	 fwrite(data, 256,1, f);

////. A single signature byte of 0x0C is included before the palette data begins.

	 char sig = 0x0C;

	 fwrite(&sig,1,1,f);

	 fwrite(pal, 256,3, f);


	fclose(f);

}//savepcx




int main(int argc, char* argv[])
{
//	printf("Hello World!\n");

	//checkKnp();

//	if (argc > 0) { globSeed = argv[0]; }

		savePcx();

	return 0;
}

